library("affy")
library("tilingArray")

celdir = "."
pdfile = "tiling.txt"

pd = read.phenoData(pdfile, fill=TRUE, as.is=TRUE, sep="\t", header=TRUE, comment.char="")

cat("Read", pdfile, "\n")

pData(pd)$File = pd$File

stopifnot(all(pd$use %in% c("no", "yes")))

fpd = pd[ pd$use=="yes", ]

cat("Table contains", nrow(pData(pd)), "rows, using",
  nrow(pData(fpd)), "\n")

pat = ".CEL$"
dirFiles = dir(celdir, pattern=pat)

stopifnot(all(fpd$File %in% dirFiles))

a = readCel2eSet(fpd$File)

pData(a) = pData(fpd)

rownames(pData(a)) = colnames(exprs(a)) = pData(a)$File

save(a, file="a.rda", compress=TRUE)
