celdir = "."
pdfile = "tiling.txt"

library(affy)

## Read the phenoData file
pd = read.phenoData(pdfile, fill=TRUE, as.is=TRUE,
  sep="\t", header=TRUE, comment.char="")
cat("Read", pdfile, "\n")

pData(pd)$File = pd$File
pat = ".CEL$"

stopifnot(all(pd$use %in% c("no", "yes")))
fpd = pd[ pd$use=="yes", ]
cat("Table contains", nrow(pData(pd)), "rows, using",
  nrow(pData(fpd)), "\n")

## Get the filenames in the directory
dirFiles = dir(celdir, pattern=pat)
stopifnot(all(fpd$File %in% dirFiles))

## OLD
#a = ReadAffy(filenames=fpd$File, celfile.path=celdir,  
#  phenoData=fpd, verbose=TRUE, compress=TRUE)
#a = new("exprSet", exprs=intensity(a), phenoData=phenoData(a))

## NEW
library("tilingArray")

#d1 = readCel2eSet("DNA1.CEL")
#d2 = readCel2eSet("DNA2.CEL")
#d3 = readCel2eSet("DNA3.CEL")

#r1 = readCel2eSet("ivt1.CEL")
#r2 = readCel2eSet("ivt2.CEL")
#r3 = readCel2eSet("ivt3.CEL")

## NEWER

a = readCel2eSet(fpd$File)

#a = new("exprSet")

#exprs(a) = as.matrix(data.frame(p=exprs(d1), q=exprs(d2), r=exprs(d3), s=exprs(r1), t=exprs(r2), u=exprs(r3)))
#phenoData(a) = fpd

#colnames(exprs(a)) = a$File

save(a, file="a.rda", compress=TRUE)

## Normalize
#jref = which(a$NucleicAcid == "DNA")
jref = which(pData(a)$NucleicAcid == "DNA")

stopifnot(length(jref)==3)

normfac = rowMeans(log(exprs(a)[, jref, drop=FALSE], 2))

#x = new("exprSet",
#  exprs = log(exprs(a)[,-jref, drop=FALSE], 2) - normfac,
#  phenoData = phenoData(a)[-jref,])

x = new("exprSet")
exprs(x) = log(exprs(a)[,-jref, drop=FALSE], 2) - normfac,
phenoData(x) = phenoData(a)[-jref,]

colnames(exprs(x)) = x$File

save(x, file="x.rda", compress=TRUE)

rm(a, d1, d2, d3, r1, r2, r3, dirFiles, pd, pdfile, celdir, fpd, jref, normfac, pat)

se.exprs(x) = matrix(data = NA, nrow = 2598544, ncol = 3)

rownames(pData(x)) = colnames(exprs(x)) = pData(x)$File

xes <- as(x, "ExpressionSet")
