options(warn=0)
#library("tilingArray")

nrBasesPerSeg = 1400

options(error=recover, warn=2)
if(!exists("probeAnno"))
  load("probeAnno-mummer.rda")

outdirs = c("seg-pombe-polyA")

if(FALSE) {
  for(d in outdirs) {
    dir.create(d); dir.create(file.path(d, "viz")) 
    system(paste("cp ", gsub("0909", "0811", d), "/xn.rda ", d, sep=""))
  }
}

#chrstr = paste(rep(1:3, each=2),
#               rep(c("+", "-"), 3), sep=".")

chrstr = c("3.+", "3.-")

allPM = unique(unlist(lapply(chrstr, function(chr)
  get(paste(chr, "index", sep="."), probeAnno))))

for(outdir in outdirs) {

  if(!file.exists(outdir))
    stop(paste("Directory '", outdir, "' does not exist.", sep=""))

  if(!file.info(outdir)$isdir)
    stop(paste("'", outdir, "' must be a directory.", sep=""))

  for(ichr in seq(along=chrstr)) {

    chr = chrstr[ichr]

    if(ichr==1) {

      load(file.path(outdir, "xn.rda"))
      lxj = exprs(xn)
      refSigThresh = quantile(refSig[allPM], probs=0.05)

    }

    datfn = file.path(outdir, paste(chr, ".rda", sep=""))

    if(!file.exists(datfn)) {

      cat("working on", datfn, "\n")
      ## Lock it
      con = file(datfn, open="wt")
      writeLines(date(), con)
      close(con)

      ## get data
      sta = get(paste(chr, "start", sep="."), probeAnno)
      end = get(paste(chr, "end", sep="."), probeAnno)
      mid = (sta+end)/2
      ord = order(mid)

      sta = sta[ord]
      end = end[ord]
      mid = mid[ord]
      ind = get(paste(chr, "index", sep="."), probeAnno)[ord]
      uni = get(paste(chr, "unique", sep="."), probeAnno)[ord]
      y   = lxj[ind,, drop=FALSE]

      ## eliminate the bad probes
      sel = (refSig[ind] >= refSigThresh)

      ## subsample to keep spacing around 8
      ss = sampleStep( mid[sel], step=7)

      dat  = list(start  = sta[sel],
                  end    = end[sel],
                  y      = y[sel,, drop=FALSE],
                  unique = uni[sel],
                  ss     = ss)

      ## see plotFeatSize: the longest structure CDS in yeast is
      ## 15k bases long, corresponding to about 2000 consecutive probes
      maxk  = 1500
      maxcp = round( (max(end)-min(sta)) / nrBasesPerSeg)

      seg = findSegments(dat$y[ss,,drop=FALSE], maxk=maxk, maxcp=maxcp, verbose=99)
      
      save(seg, dat, file=datfn, compress=TRUE)
    } else {
      cat(datfn, "exists, skipping.\n")
    } ## if
  } # for chr
} ## for outdir
