library(tilingArray)
load("probeAnno.rda")

e1 = readCel2eSet("sbw_tot_poly1.cel",rotated=TRUE)
e2 = readCel2eSet("sbw_tot_poly2.cel",rotated=TRUE)
e3 = readCel2eSet("sbw_genomic_dnase1.cel",rotated=TRUE)
e4 = readCel2eSet("sbw_genomic_dnase2.cel",rotated=TRUE)
e5 = readCel2eSet("sbw_genomic_dnase3.cel",rotated=TRUE)

sta=probeAnno$"2.-.start"
end=probeAnno$"2.-.end"
ind=probeAnno$"2.-.index"

dat=vector(mode="list",length=3)
dat[[1]]= ((log2(exprs(e1)[ind])+log2(exprs(e2)[ind]))/2)
dat[[2]]=((log2(exprs(e3)[ind])+log2(exprs(e4)[ind])+log2(exprs(e5)[ind]))/3)
dat[[3]]=dat[[1]]-dat[[2]]

sel=(sta >= 4239125 & end <= 4242126)
ysc=sapply(dat,function(py) quantile(py,probs=c(0,1),na.rm=TRUE))
anno=data.frame(start=c(4240125), end=c(4241126),
name=I(c("SPBC16G5.14c")))
ticks=c(4239,4240,4241,4242,4243)
comparisonPlot((sta+end)[sel]/2, lapply(dat, "[", sel),
yscale=ysc,anno=anno, ticks=ticks, cex=0.1)

